
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Mock_trial_rolesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const mock_trial_roles = await db.mock_trial_roles.create(
            {
                id: data.id || undefined,
        
        role_name: data.role_name
        ||
        null
            ,
            
        actor_type: data.actor_type
        ||
        null
            ,
            
        display_name: data.display_name
        ||
        null
            ,
            
        instructions: data.instructions
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await mock_trial_roles.setMock_trial( data.mock_trial || null, {
            transaction,
        });
        

        

        

        return mock_trial_roles;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const mock_trial_rolesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                role_name: item.role_name
            ||
            null
            ,
            
                actor_type: item.actor_type
            ||
            null
            ,
            
                display_name: item.display_name
            ||
            null
            ,
            
                instructions: item.instructions
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const mock_trial_roles = await db.mock_trial_roles.bulkCreate(mock_trial_rolesData, { transaction });

        // For each item created, replace relation files
        

        return mock_trial_roles;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const mock_trial_roles = await db.mock_trial_roles.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.role_name !== undefined) updatePayload.role_name = data.role_name;
        
        
        if (data.actor_type !== undefined) updatePayload.actor_type = data.actor_type;
        
        
        if (data.display_name !== undefined) updatePayload.display_name = data.display_name;
        
        
        if (data.instructions !== undefined) updatePayload.instructions = data.instructions;
        
        
        updatePayload.updatedById = currentUser.id;

        await mock_trial_roles.update(updatePayload, {transaction});

        
        
        if (data.mock_trial !== undefined) {
            await mock_trial_roles.setMock_trial(
              
              data.mock_trial,
              
              { transaction }
            );
        }
        

        
        

        

        return mock_trial_roles;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const mock_trial_roles = await db.mock_trial_roles.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of mock_trial_roles) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of mock_trial_roles) {
                await record.destroy({transaction});
            }
        });


        return mock_trial_roles;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const mock_trial_roles = await db.mock_trial_roles.findByPk(id, options);

        await mock_trial_roles.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await mock_trial_roles.destroy({
            transaction
        });

        return mock_trial_roles;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const mock_trial_roles = await db.mock_trial_roles.findOne(
            { where },
            { transaction },
        );

        if (!mock_trial_roles) {
            return mock_trial_roles;
        }

        const output = mock_trial_roles.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.mock_trial_turns_role = await mock_trial_roles.getMock_trial_turns_role({
            transaction
        });
        
        
        
        
        
        
        
        
        output.mock_trial = await mock_trial_roles.getMock_trial({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.mock_trials,
        as: 'mock_trial',
        
        where: filter.mock_trial ? {
          [Op.or]: [
            { id: { [Op.in]: filter.mock_trial.split('|').map(term => Utils.uuid(term)) } },
            {
              session_title: {
                [Op.or]: filter.mock_trial.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.display_name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'mock_trial_roles',
                        'display_name',
                        filter.display_name,
                    ),
                };
            }
            
            if (filter.instructions) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'mock_trial_roles',
                        'instructions',
                        filter.instructions,
                    ),
                };
            }
            

            
            

            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.role_name) {
                where = {
                    ...where,
                role_name: filter.role_name,
            };
            }
            
            if (filter.actor_type) {
                where = {
                    ...where,
                actor_type: filter.actor_type,
            };
            }
            


      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.mock_trial_roles.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'mock_trial_roles',
                        'display_name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.mock_trial_roles.findAll({
            attributes: [ 'id', 'display_name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['display_name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.display_name,
        }));
    }

    
};

